// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from Merchant.djinni

#import "VFIAcquirer.h"
#import "VFIDecimal.h"
#import <Foundation/Foundation.h>

/** Represents a merchant. */
@interface VFIMerchant : NSObject
- (nonnull instancetype)initWithRecordId:(nullable NSString *)recordId
                            merchantName:(nullable NSString *)merchantName
                         merchantAddress:(nullable NSString *)merchantAddress
                             countryCode:(nullable NSString *)countryCode
                    merchantCategoryCode:(nullable NSString *)merchantCategoryCode
                           isPrimaryFlag:(nullable NSNumber *)isPrimaryFlag
                        isBalanceEnquiry:(nullable NSNumber *)isBalanceEnquiry
                          cashoutCeiling:(nullable VFIDecimal *)cashoutCeiling
                    isCashoutOnlyEnabled:(nullable NSNumber *)isCashoutOnlyEnabled
                   isForceOfflineEnabled:(nullable NSNumber *)isForceOfflineEnabled
                  isManualPreAuthEnabled:(nullable NSNumber *)isManualPreAuthEnabled
                 isManualPurchaseEnabled:(nullable NSNumber *)isManualPurchaseEnabled
                   isManualRefundEnabled:(nullable NSNumber *)isManualRefundEnabled
                       maxPurchaseAmount:(nullable VFIDecimal *)maxPurchaseAmount
                    isMotoPaymentEnabled:(nullable NSNumber *)isMotoPaymentEnabled
                     isMotoRefundEnabled:(nullable NSNumber *)isMotoRefundEnabled
                             phoneNumber:(nullable NSString *)phoneNumber
                        isPreAuthEnabled:(nullable NSNumber *)isPreAuthEnabled
             isPurchaseAndCashoutEnabled:(nullable NSNumber *)isPurchaseAndCashoutEnabled
                       isPurchaseEnabled:(nullable NSNumber *)isPurchaseEnabled
                         isRefundEnabled:(nullable NSNumber *)isRefundEnabled
                      isTipPromptEnabled:(nullable NSNumber *)isTipPromptEnabled
                           isVoidEnabled:(nullable NSNumber *)isVoidEnabled
                               acquirers:(nonnull NSArray<VFIAcquirer *> *)acquirers;
+ (nonnull instancetype)MerchantWithRecordId:(nullable NSString *)recordId
                                merchantName:(nullable NSString *)merchantName
                             merchantAddress:(nullable NSString *)merchantAddress
                                 countryCode:(nullable NSString *)countryCode
                        merchantCategoryCode:(nullable NSString *)merchantCategoryCode
                               isPrimaryFlag:(nullable NSNumber *)isPrimaryFlag
                            isBalanceEnquiry:(nullable NSNumber *)isBalanceEnquiry
                              cashoutCeiling:(nullable VFIDecimal *)cashoutCeiling
                        isCashoutOnlyEnabled:(nullable NSNumber *)isCashoutOnlyEnabled
                       isForceOfflineEnabled:(nullable NSNumber *)isForceOfflineEnabled
                      isManualPreAuthEnabled:(nullable NSNumber *)isManualPreAuthEnabled
                     isManualPurchaseEnabled:(nullable NSNumber *)isManualPurchaseEnabled
                       isManualRefundEnabled:(nullable NSNumber *)isManualRefundEnabled
                           maxPurchaseAmount:(nullable VFIDecimal *)maxPurchaseAmount
                        isMotoPaymentEnabled:(nullable NSNumber *)isMotoPaymentEnabled
                         isMotoRefundEnabled:(nullable NSNumber *)isMotoRefundEnabled
                                 phoneNumber:(nullable NSString *)phoneNumber
                            isPreAuthEnabled:(nullable NSNumber *)isPreAuthEnabled
                 isPurchaseAndCashoutEnabled:(nullable NSNumber *)isPurchaseAndCashoutEnabled
                           isPurchaseEnabled:(nullable NSNumber *)isPurchaseEnabled
                             isRefundEnabled:(nullable NSNumber *)isRefundEnabled
                          isTipPromptEnabled:(nullable NSNumber *)isTipPromptEnabled
                               isVoidEnabled:(nullable NSNumber *)isVoidEnabled
                                   acquirers:(nonnull NSArray<VFIAcquirer *> *)acquirers;

/** record id of the merchant */
@property (nonatomic, readonly, nullable) NSString * recordId;

/** The name of the merchant as set by the merchant. */
@property (nonatomic, readonly, nullable) NSString * merchantName;

/** The address of the merchant */
@property (nonatomic, readonly, nullable) NSString * merchantAddress;

/** The ISO 3166-1 country code where the merchant is operating */
@property (nonatomic, readonly, nullable) NSString * countryCode;

/** The ISO18245 category code for the merchant */
@property (nonatomic, readonly, nullable) NSString * merchantCategoryCode;

/** If this merchant is the primary merchant on the POI */
@property (nonatomic, readonly, nullable) NSNumber * isPrimaryFlag;

/** Balance Enquiry Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isBalanceEnquiry;

/** Cashout Ceiling */
@property (nonatomic, readonly, nullable) VFIDecimal * cashoutCeiling;

/** is cash out only enabled */
@property (nonatomic, readonly, nullable) NSNumber * isCashoutOnlyEnabled;

/** is Force offline Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isForceOfflineEnabled;

/** is Manual Pre auth enabled */
@property (nonatomic, readonly, nullable) NSNumber * isManualPreAuthEnabled;

/** is Manual Purchase Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isManualPurchaseEnabled;

/** is Manual Refund Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isManualRefundEnabled;

/** maximum purchase Amount */
@property (nonatomic, readonly, nullable) VFIDecimal * maxPurchaseAmount;

/** isMotoPaymentEnabled */
@property (nonatomic, readonly, nullable) NSNumber * isMotoPaymentEnabled;

/** isMotoRefundEnabled */
@property (nonatomic, readonly, nullable) NSNumber * isMotoRefundEnabled;

/** phone number */
@property (nonatomic, readonly, nullable) NSString * phoneNumber;

/** is Pre Auth Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isPreAuthEnabled;

/** is Purchase And Cash out Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isPurchaseAndCashoutEnabled;

/** is Purchase Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isPurchaseEnabled;

/** is Refund Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isRefundEnabled;

/** is Tip PRompt Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isTipPromptEnabled;

/** is Void Enabled */
@property (nonatomic, readonly, nullable) NSNumber * isVoidEnabled;

/** An array of PaymentAcquirerData objects without payment information */
@property (nonatomic, readonly, nonnull) NSArray<VFIAcquirer *> * acquirers;

@end

/** name of the merchant */
extern NSString * __nonnull const VFIMerchantMERCHANTNAMECOLUMN;
/** address of the merchant */
extern NSString * __nonnull const VFIMerchantMERCHANTADDRESSCOLUMN;
